/*

    File: bsd.c

    Copyright (C) 1998-2001  Christophe Grenier <grenier@nef.esiea.fr>
  
    This software is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

 */

#include <stdio.h>
#include "types.h"
#include "common.h"
#include "bsd.h"
#include "interface.h"
#include "fnctdsk.h"

int test_bsd(t_param_disk_cst disk_car,struct disklabel *bsd_header,t_diskext partition, int debug)
{
  if((bsd_header->d_magic == DISKMAGIC)&&(bsd_header->d_magic2==DISKMAGIC))
  {
    int i;
    int i_max_p_offset=0;
    u_int16_t* cp;
    u_int16_t crc;
    if(debug)
      ecrit_rapport("\nBSD offset %d, nbr_part %d/%d, ",partition->lba,bsd_header->d_npartitions,MAXPARTITIONS);
    if(bsd_header->d_npartitions>MAXPARTITIONS)
      return 1;
    crc=0;
    for(cp=(u_int16_t*)bsd_header;
	cp<(u_int16_t*)&bsd_header->d_partitions[MAXPARTITIONS+1];cp++)
      crc^=*cp;
    if(debug)
    {
      if(!crc)
		ecrit_rapport("CRC Ok");
	  else
		ecrit_rapport("Bad CRC! CRC must be xor'd by %04X",crc);
    }
    if(crc)
      return 1;
    for(i=0;i<MAXPARTITIONS;i++)
    {
      if(bsd_header->d_partitions[i].p_fstype>0)
      {
	if(debug)
	{
	  ecrit_rapport("\nBSD type %02X offset %d size %d \t",
	      bsd_header->d_partitions[i].p_fstype,
	      bsd_header->d_partitions[i].p_offset,
	      bsd_header->d_partitions[i].p_size);
	  aff_LBA2CHS_rapport(disk_car,bsd_header->d_partitions[i].p_offset);
	  ecrit_rapport("->");
	  aff_LBA2CHS_rapport(disk_car,bsd_header->d_partitions[i].p_offset+bsd_header->d_partitions[i].p_size-1);
	}
	if(bsd_header->d_partitions[i].p_offset>bsd_header->d_partitions[i_max_p_offset].p_offset)
	  i_max_p_offset=i;
      }
    }
    partition->part_size=bsd_header->d_partitions[i_max_p_offset].p_size+
      bsd_header->d_partitions[i_max_p_offset].p_offset- partition->lba -1;
    partition->part_type=P_BSD;
    return 0;
  }
  return 1;
}
